% Autor: Wiebke Petersen
% original: manual of clpfd
% Datum: 11.05.2017

% sudoku solver with constraints (using all_distinct)
% ?- problem(1, Rows), sudoku(Rows), maplist(writeln, Rows).
% Try what happens if the problem has more than one solution (problem 3) and improve it to handle such problems

:- use_module(library(clpfd)).
:- use_module(library(lists)).
:- use_module(library(apply)).

play(Rows,Rows):-
        length(Rows, 9), maplist(same_length(Rows), Rows),
        append(Rows, Vs), Vs ins 1..9,
        maplist(all_distinct, Rows),
        transpose(Rows, Columns),
        maplist(all_distinct, Columns),
        Rows = [As,Bs,Cs,Ds,Es,Fs,Gs,Hs,Is],
        blocks(As, Bs, Cs),
        blocks(Ds, Es, Fs),
        blocks(Gs, Hs, Is).

blocks([], [], []).
blocks([N1,N2,N3|Ns1], [N4,N5,N6|Ns2], [N7,N8,N9|Ns3]) :-
        all_distinct([N1,N2,N3,N4,N5,N6,N7,N8,N9]),
        blocks(Ns1, Ns2, Ns3).


%%%%%%%%%%%%
print_board(B):- maplist(writeln,B).